﻿/***********************************************************************************
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://sharepointjavascript.wordpress.com
 * Copyright (c) 2009-2015 Alexander Bautz (Licensed under the MIT X11 License)
************************************************************************************/

/*
JSLint
var $, GetUrlKeyValue, _spPageContextInfo, SP, window, setTimeout, parent, L_Menu_BaseUrl, L_Menu_LCID, alert, fields, ExecuteOrDelayUntilScriptLoaded, 
SPClientPeoplePicker, document, browseris, IsAccessibilityFeatureEnabled, Microsoft;
*/

/* SP2013 */
if(typeof _spPageContextInfo !== "undefined"){
	if(_spPageContextInfo.webUIVersion === 15){
		var L_Menu_BaseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		var L_Menu_LCID = _spPageContextInfo.currentLanguage.toString();
	}
}

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace. 
spjs.$ = spjs.$ || $;

spjs.utility = {
	"version":1.206,
	"versionDate":"February 24, 2015",
	"resizeDlg":function(){
		if(GetUrlKeyValue('IsDlg')!=='1' || typeof _spPageContextInfo === "undefined"){
			return;
		}		
		var dlg, scroll, dlgWin, css, iH, rH, s4Height;
		if(_spPageContextInfo.webUIVersion === 15){
			dlg = SP.UI.ModalDialog.get_childDialog();
			scroll = spjs.$("#s4-workspace").scrollTop();
			dlgWin = spjs.$(".ms-dlgContent", window.parent.document);
			css = {};
			if(dlg !== null && !dlg.get_isMaximized()){
				dlg.autoSize();
				css.top = (spjs.$(window.top).height() / 2 - dlgWin.height() / 2) + "px";
				dlgWin.css({"top":css.top});
				// Reapply scroll
				spjs.$("#s4-workspace").scrollTop(scroll);
			}
		}else{
			dlg = SP.UI.ModalDialog.get_childDialog();
			scroll = spjs.$("#s4-workspace").scrollTop();
			if(dlg !== null && !dlg.$S_0 && dlg.get_$Z_0()){
				setTimeout(function(){
					dlg.$T_0 = (spjs.$(parent.window).width() / 2) - (dlg.$B_0 / 2);
					dlg.$U_0 = (spjs.$(parent.window).height() / 2) - (dlg.$A_0 / 2);
					dlg.$m_0(dlg.$T_0, dlg.$U_0);
					dlg.autoSize();
					dlg.$2B_0();
					// Fix missig scrollbar
					iH = spjs.$(parent.document).find("#"+dlg.$0_0.id).height();
					rH = spjs.$("#s4-ribbonrow").height();
					s4Height = iH-rH;
					if(s4Height < 300){
						s4Height = 300;
					}
					spjs.$("#s4-workspace").css("height",s4Height);
					// Fix missig scrollbar
					spjs.$("#s4-workspace").scrollTop(scroll);
				},150);
			}
		}
	},
	"addList":function(listName,listBaseUrl,listDescription){
		var c, r;
		c = [];
		c.push("<AddList xmlns='http://schemas.microsoft.com/sharepoint/soap/'>");
		c.push("<listName>"+listName+"</listName>");
		c.push("<description>"+listDescription+"</description>");
		c.push("<templateID>100</templateID>");
		c.push("</AddList>");
		r = {success:false};
		spjs.utility.wrapSoap(listBaseUrl+"/_vti_bin/lists.asmx","http://schemas.microsoft.com/sharepoint/soap/AddList",c.join(''),function(data){
			if(spjs.$(data).find('ErrorText').length>0) {
				r.errorText = spjs.$(data).find('ErrorText').text();
				r.errorCode = spjs.$(data).find('ErrorCode').text();
			}else{
				r.success=true;
				r.id = spjs.$(data).find('List').attr('ID');
			}
		});
		return r;
	},
	"updateList":function(listName,listBaseUrl,newFieldsObjArr,updFieldsObjArr,deleteFieldsArr){
		var nb, ub, db, mi, c, cb, fb, r, addToView;
		nb = [];
		ub = [];
		db = [];
		mi = 1;
		spjs.$.each(newFieldsObjArr,function(i,obj){
			c = '';
			fb = [];
			addToView = false;
			spjs.$.each(obj,function(p,v){		
				if(p==='content'){
					c = v;
				}else{
					if(p === 'AddToView'){
						addToView = true;
					}else{				
						fb.push(" "+p+"=\""+v+"\"");
					}
				}
			});
			nb.push("<Method ID='"+mi+"'");
				if(addToView){
					nb.push(" AddToView=''");
				}
			nb.push("><Field "+fb.join(''));
			if(c===''){
				nb.push(" /></Method>");
			}else{
				nb.push(">"+c+"</Field></Method>");
			}
			mi+=1;
		});
		spjs.$.each(updFieldsObjArr,function(i,obj){
			c = '';
			fb = [];
			addToView = false;
			spjs.$.each(obj,function(p,v){
				if(p==='content'){
					c = v;
				}else{
					if(p === 'AddToView'){
						addToView = true;
					}else{
						fb.push(" "+p+"=\""+v+"\"");
					}
				}
			});
			ub.push("<Method ID='"+mi.toString()+"'");		
				if(addToView){
					ub.push(" AddToView=''");
				}
	
			ub.push("><Field "+fb.join(''));
			if(c===''){
				ub.push(" /></Method>");
			}else{
				ub.push(">"+c+"</Field></Method>");
			}
			mi+=1;
		});
		if(deleteFieldsArr !== undefined){
			spjs.$.each(deleteFieldsArr,function(i,fin){
				db.push("<Method ID='"+mi+"'><Field Name=\""+fin+"\" /></Method>");
				mi+=1;
			});
		}
		cb = [];
		cb.push("<UpdateList xmlns='http://schemas.microsoft.com/sharepoint/soap/'>");
		cb.push("<listName>"+listName+"</listName>");
		if(nb.length>0){
			cb.push("<newFields>");
			cb.push("<Fields>");
			cb.push(nb.join(''));
			cb.push("</Fields>");
			cb.push("</newFields>");
		}
		if(ub.length>0){
			cb.push("<updateFields>");
			cb.push("<Fields>");
			cb.push(ub.join(''));
			cb.push("</Fields>");
			cb.push("</updateFields>");
		}
		if(db.length>0){
			cb.push("<deleteFields>");
			cb.push("<Fields>");
			cb.push(db.join(''));
			cb.push("</Fields>");
			cb.push("</deleteFields>");
		}
		cb.push("</UpdateList>");
		r = {success:false};
		spjs.utility.wrapSoap(listBaseUrl+"/_vti_bin/lists.asmx","http://schemas.microsoft.com/sharepoint/soap/UpdateList",cb.join(''),function(data){
			if(spjs.$(data).find('ErrorText').length>0) {
				r.errorText = spjs.$(data).find('ErrorText').text();
				r.errorCode = spjs.$(data).find('ErrorCode').text();
			}else{
				r.success=true;
			}
		});
		return r;
	},
	"userInfo":function(loginOrUserID,customProp){
		var arrOfFields, query, res, result, item;	
		result = {success:false};
		arrOfFields = ['ID', 'Name', 'Title', 'EMail', 'Department', 'JobTitle', 'Notes', 'Picture', 'IsSiteAdmin', 'Created', 'Author', 'Modified', 'Editor', 'SipAddress'];
		if(customProp !== undefined){
			if(spjs.$.isArray(customProp)){
				spjs.$.each(customProp,function(i,p){
					arrOfFields.push(p);
				});
			}else{
				arrOfFields.push(customProp);
			}
		}
		if(parseInt(loginOrUserID,10).toString()===loginOrUserID.toString()){
			query = "<Where><Eq><FieldRef Name='ID' /><Value Type='Integer'>" + loginOrUserID + "</Value></Eq></Where>";
		}else{
			query = "<Where><Eq><FieldRef Name='Name' /><Value Type='Text'>" + loginOrUserID + "</Value></Eq></Where>";
		}
		res = spjs.utility.queryItems({'listName':'UserInfo','listBaseUrl':L_Menu_BaseUrl,'query':query,'viewFields':arrOfFields,setRequestHeader:false}); 
	    if(res.count>0){ 
	    	result.success=true;
	    	item = res.items[0];
		    spjs.$.each(arrOfFields,function(i,fin){
		    	result[arrOfFields[i]] = item[arrOfFields[i]];    
		    });
	       	return result; 	
	    }else{
	       result.success = false; 
	       return result;
		}
	},
	"getItemByID":function(argObj){		
		if(String(parseInt(String(argObj.id),10)) !== String(argObj.id)){
			return null;
		}
		var query, qRes;
		query = "<Where><Eq><FieldRef Name='ID' /><Value Type='Text'>"+argObj.id+"</Value></Eq></Where>";
		qRes = spjs.utility.queryItems({'listName':argObj.listName,'listBaseUrl':argObj.listBaseUrl,'query':query,'viewFields':argObj.viewFields,'scope':argObj.scope});
		if(qRes.count===0){
			return null;
		}else{
			return qRes.items[0];
		}
	},
	"queryItems":function(argObj){
		var content, result, requestHeader, currID, fieldValObj, value;
		if(argObj.listBaseUrl===undefined){
			argObj.listBaseUrl=L_Menu_BaseUrl;
		}
		if(argObj.listName===undefined || (argObj.query===undefined && argObj.viewName===undefined)){
			alert("[spjs.utility.queryItems]\n\nMissing parameters!\n\nYou must provide a minimum of \"listName\", \"query\" or \"viewName\" and \"viewFields\".");
			return;
		}
		if(spjs.$.inArray('ID',argObj.viewFields)===-1){
			argObj.viewFields.push('ID');
		}		
		content = spjs.utility.wrapQuery({'listName':argObj.listName, 'query':argObj.query, 'folder':argObj.folder, 'viewName':argObj.viewName, 'viewFields':argObj.viewFields, 'rowLimit':argObj.rowLimit, 'pagingInfo':argObj.pagingInfo,'scope':argObj.scope});
		result = {'count':-1, 'nextPagingInfo':'', items:[]};	
		if(argObj.setRequestHeader===false){
			requestHeader  = '';
		}else{
			requestHeader  = 'http://schemas.microsoft.com/sharepoint/soap/GetListItems';
		}
		spjs.utility.wrapSoap(argObj.listBaseUrl + '/_vti_bin/lists.asmx',requestHeader, content, function(data){
			result.count = parseInt(spjs.$(data).filterNode("rs:data").attr('ItemCount'),10);
			result.nextPagingInfo = spjs.$(data).filterNode("rs:data").attr('ListItemCollectionPositionNext');
			fieldValObj = {};
			spjs.$(data).filterNode('z:row').each(function(idx, itemData){
				currID = spjs.$(itemData).attr('ows_ID');
				fieldValObj[currID] = {};
				spjs.$.each(argObj.viewFields,function(i,field){
					value = spjs.$(itemData).attr('ows_' + field);
					if(value === undefined){
						value = null;
					}
					fieldValObj[currID][field] = value;
				});
				result.items.push(fieldValObj[currID]);
			});
		});
		return result;
	},
	"wrapQuery":function(a){
		var result = [];
		result.push('<GetListItems xmlns="http://schemas.microsoft.com/sharepoint/soap/">');
		result.push('<listName>' + a.listName + '</listName>');
		if(a.viewName!==undefined && a.viewName!==''){
			result.push('<viewName>' + a.viewName + '</viewName>');
		}
		if(a.query!==null && a.query!==''){
			result.push('<query><Query xmlns="">');
			result.push(a.query);
			result.push('</Query></query>');
		}
		if(a.viewFields!==undefined && a.viewFields!=='' && a.viewFields.length>0){
			result.push('<viewFields><ViewFields xmlns="">');
			spjs.$.each(a.viewFields, function(idx, field){
				result.push('<FieldRef Name="' + field + '"/>');
			});
			result.push('</ViewFields></viewFields>');
		}
		// A view overrides the itemlimit
		if(a.viewName===undefined){
			if(a.rowLimit!==undefined && a.rowLimit>0){
				result.push('<rowLimit>' + a.rowLimit + '</rowLimit>');
			}else{
			    result.push('<rowLimit>100000</rowLimit>');
			}
		}
		result.push('<queryOptions><QueryOptions xmlns=""><IncludeMandatoryColumns>FALSE</IncludeMandatoryColumns>');
		if(a.pagingInfo!==undefined && a.pagingInfo!==null && a.pagingInfo!==''){
			result.push('<Paging ListItemCollectionPositionNext="' + a.pagingInfo.replace(/&/g, '&amp;') + '" />');
		}
		if(a.scope !== undefined){
			result.push('<ViewAttributes Scope="'+a.scope+'" />');
		}
		if(a.folder !== undefined){
			result.push('<Folder>'+a.folder+'</Folder>');
		}
		result.push('</QueryOptions></queryOptions>');
		result.push('</GetListItems>');
		return result.join('');
	},
	"wrapSoap":function(webserviceUrl,requestHeader,soapBody,successFunc){
		var xmlWrap = [], r;
			xmlWrap.push("<?xml version='1.0' encoding='utf-8'?>");
			xmlWrap.push("<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/'>");
			xmlWrap.push("<soap:Body>");
			xmlWrap.push(soapBody);
			xmlWrap.push("</soap:Body>");
			xmlWrap.push("</soap:Envelope>");
			xmlWrap = xmlWrap.join('');
		spjs.$.ajax({
			async:false,
			type:"POST",
			url:webserviceUrl,
			contentType:"text/xml; charset=utf-8",
			processData:false,
			data:xmlWrap,
			dataType:"xml",
			beforeSend:function(xhr){
				if(requestHeader!==''){
					xhr.setRequestHeader('SOAPAction',requestHeader);
				}
			},
			success:successFunc,
			error:function (xhr, ajaxOptions, thrownError){
				r = xhr.responseText.match(/<errorstring[^>]*>(.*)<\/errorstring>/i);
				if(r !== null){
					spjs.$("body").prepend("<div style='color:red;background-color:#ffff32;padding:3px;'>"+r[1]+"</div>");
				}
			} 
		});
	},
	"setFieldValue":function(fin,newVal,onLoad){
		if(typeof onLoad === "undefined"){
			onLoad = true;
		}
		// If not already done - init all fields
		if(typeof fields === "undefined"){
			fields = spjs.utility.init_fields();
		}
		// Return if FieldInternalName is not found
		if(fields[fin]===undefined){
			return;
		}
		var isSP13, thisField, fieldType, optText, inputField, inputFieldHidden, split, newValueBuffer, id, friendlyVal, match, t, a, b, c;
		isSP13 = false;
		if(typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15){
			isSP13 = true;
		}
		thisField = spjs.$(fields[fin]);
		fieldType = spjs.$(fields[fin]).attr('FieldType');
		if(fieldType === undefined){
			alert("[setFieldValue]\nThe attribute \"FieldType\" is missing for the FieldInternalName \""+fin+"\".");
			return false;
		}
		switch(fieldType){
			case 'ContentTypeChoice':
				thisField.find('select option').each(function(){
					if(spjs.$(this).text() === newVal){
						spjs.$(this).prop('selected',true).parent().change();					
					}
				});
			break;
			case 'SPFieldText':
			case 'SPFieldFile':
			case 'SPFieldNumber':
			case 'SPFieldCurrency':
				thisField.find('input').val(newVal);
			break;
			case 'SPFieldChoice':
				if(thisField.find('input:radio').length>0){
					thisField.find('input:radio').prop("checked",false);
					thisField.find('input:radio').each(function(){
						if(spjs.$(this).next().text()===newVal){
							spjs.$(this).prop('checked','checked');
						}
					});
				}else{
					thisField.find('select option').each(function(){
						if(spjs.$(this).text() === newVal){
							spjs.$(this).prop('selected',true);
						}
					});
				}
			break;
			case 'SPFieldMultiChoice':
				if(typeof newVal !== "object"){
					newVal=newVal.split(',');
				}
				thisField.find('input:checkbox').each(function(){
					optText = spjs.$(this).next().text();
					if(spjs.$.inArray(optText,newVal)>-1){
						spjs.$(this).prop('checked',true);
					}else{
						spjs.$(this).prop('checked',false);
					}
				});
				break;
		    case 'SPFieldGridChoice':
		        if (typeof newVal !== "object") {
		            newVal = newVal.split(',');
		        }
alert('NOT SUPPORTED YET!!!');
		        thisField.find('input:checkbox').each(function () {
		            optText = spjs.$(this).next().text();
		            if (spjs.$.inArray(optText, newVal) > -1) {
		                spjs.$(this).prop('checked', true);
		            } else {
		                spjs.$(this).prop('checked', false);
		            }
		        });

			case 'SPFieldUser':
			case 'SPFieldUserMulti':	
				if(isSP13){					
						ExecuteOrDelayUntilScriptLoaded(function(){
							setTimeout(function(){
								try{
									var p = SPClientPeoplePicker.SPClientPeoplePickerDict[thisField.find("div.sp-peoplepicker-topLevel").attr("id")];					
									if(newVal === ""){
										p.DeleteProcessedUser();
										return;
									}
									if(!p.AllowMultipleUsers){
										p.DeleteProcessedUser();
									}
									if(!spjs.$.isArray(newVal)){
										newVal = newVal.split(/;|,/);
									}
									spjs.$.each(newVal,function(i,v){
										document.getElementById(p.EditorElementId).value = spjs.$.trim(v);
										p.AddUnresolvedUserFromEditor(true);
									});
								}catch(ignore){
									//
								}
							},1000);
						},'clientpeoplepicker.js');					
				}else{
					spjs.$(document).ready(function(){
						thisField.find('div.ms-inputuserfield').html(newVal);
						thisField.find('textarea:first').val(newVal);
						thisField.find('img:first').click();
					});
				}		
			break;
			case 'SPFieldLookup':
				thisField.find('select option').each(function(){	
					if(spjs.$(this).text()===newVal){ // By text value				
						spjs.$(this).parent().val(spjs.$(this).val());
						return false;
					}
					if(spjs.$(this).val()===newVal){ // By ID		
						spjs.$(this).parent().val(spjs.$(this).val());
						return false;
					}
				});
			break;
			case 'SPFieldLookup_Input':
				inputField = thisField.find('input.ms-lookuptypeintextbox');
				inputFieldHidden = spjs.$("*[id='"+inputField.attr('optHid')+"']");
				split = inputField.attr('choices').split('|');
				match = false;
				// By text
				spjs.$.each(split,function(i,val){
					if(i%2!==0){
						return;
					}
					if(val===newVal){
						inputField.val(split[i]);
						inputFieldHidden.val(split[i+1]);
						match = true;
						return false;
					}
				});
				// By ID
				if(!match){	
					spjs.$.each(split,function(i,val){
						if(i%2===0){
							return;
						}
						if(val===newVal){
							inputField.val(split[i-1]);
							inputFieldHidden.val(split[i]);
							return false;
						}
					});
				}
			break;
			case 'SPFieldLookupMulti':
				if(typeof newVal !== "object"){
					newVal=newVal.split(',');
				}
				if(onLoad){					
					split = thisField.find('input:hidden[id$="Picker_data"]').val().split('|t');
					newValueBuffer = [];
					spjs.$.each(split,function(i,val){
						if(i%4 !== 0){
							return;
						}
						id = val;
						friendlyVal = split[i+1];
						if(spjs.$.inArray(friendlyVal,newVal)>-1){
							newValueBuffer.push(id+'|t'+friendlyVal);
						}
					});
					thisField.find('input:hidden[id$="Picker_initial"]').val(newValueBuffer.join('|t'));
				}else{
					spjs.$.each(newVal,function(i,val){
						thisField.find("select:first option:selected").prop("selected",false);
						thisField.find("select:first option[title='"+val+"']").prop("selected",true);
						thisField.find("select:first option:selected").appendTo(thisField.find("select:last"));
					});
				}
			break;
			case 'SPFieldBoolean':
				if(newVal === 1 || newVal === "1" || newVal === true || newVal === "true"){
					thisField.find('input').prop('checked',true);
				}else{
					thisField.find('input').prop('checked',false);
				}
			break;
			case 'SPFieldURL':
				if(typeof newVal !== "object"){
					newVal = newVal.split(',');
				}
				thisField.find('input:first').val(newVal[0]);
				thisField.find('input:last').val(newVal[1]);
			break;
			case 'SPFieldDateTime':
				if(typeof newVal !== "object"){
					newVal = newVal.split(',');
				}
				a = newVal[0].match(/[^\d]/);				
				if(a !== null){
					a = a.toString();
					b = newVal[0].split(a);
					c = [];
					c.push(b[0].length < 2 ? "0"+ b[0] : b[0].length > 4 ? b[0].substring(0,4) : b[0]);
					c.push(b[1].length < 2 ? "0"+ b[1] : b[1].length > 4 ? b[1].substring(0,4) : b[1]);
					c.push(b[2].length < 2 ? "0"+ b[2] : b[2].length > 4 ? b[2].substring(0,4) : b[2]);				
					newVal[0] = c.join(a);
				}				
				thisField.find('input:first').val(newVal[0]);
				if(newVal[1] !== undefined){
					thisField.find('select:first option:eq('+newVal[1]+')').prop("selected","selected");
				}
				if(newVal[2] !== undefined){
					newVal[2] = newVal[2] - (newVal[2] % 5);
					if(newVal[2] < 10){
						newVal[2] = "0"+newVal[2];
					}
					thisField.find('select:last').val(newVal[2]);
				}
			break;
			case 'SPFieldNote':
				if(thisField.find('textarea').length===0){
					thisField.find("div[contenteditable='true']").html(newVal);
				}else{
					thisField.find('textarea:first').val(newVal);
				}
			break;
			case 'SPFieldNote_HTML':
				if(onLoad){
					thisField.find('textarea:first').val(newVal);
				}else{
					if(browseris.ie5up && browseris.win32 && !IsAccessibilityFeatureEnabled()){
						thisField.find('iframe.ms-rtelong').contents().find('body').html('<div>' + newVal + '</div>');
					}else{
						thisField.find('textarea:first').val(newVal);
					}
				}
			break;
			case 'SPFieldNote_EHTML':
				thisField.find("div[id$='TextField_inplacerte']").html(newVal);
			break;
			case 'SPFieldTaxonomyFieldType':
			case 'SPFieldTaxonomyFieldTypeMulti':
				t = new Microsoft.SharePoint.Taxonomy.ControlObject(thisField.find("div.ms-taxonomy")[0]);
				t.setTextAndCursor(newVal,false);
				t.validateAll();
			break;
			default:
				alert("Unknown fieldType: "+fieldType);
				return;
		}
		if(thisField.find("td.dffs-readonly-inner").length > 0){
			thisField.find("td.dffs-readonly-inner div.dffs_tdWrap").html(spjs.utility.getFieldValue({"fin":fin}));	
		}
	},
	"urlKeyValue":function(key,url){
		var a = "", b = unescape(window.location.search), c, d;
		if(url !== undefined){
			b = unescape(url);
		}
		if(b.length>0){
			c = b.substring(1).split('&');
			$.each(c,function(i,item){
				d = item.split('=');
				if(d[0]===key){
					a = d[1];
					if(d.length===3){
						a += "="+d[2];
					}
					return false; // exit loop
				}
			});
		}
		return unescape(a);
	},
	"getFieldValue":function(a){
		if(a.fin === "ID"){
			return spjs.utility.urlKeyValue("ID");
		}
		// If not already done - init all fields
		if(typeof fields === "undefined"){
			fields = spjs.utility.init_fields();
		}
		// Return if FieldInternalName is not found
		if(fields[a.fin]===undefined){
			return;
		}
		var isSP13, thisField, valRaw, fieldType, getFieldValueReturnVal, multiChoice, userMulti, lookupMulti, link, descr, date, hour = "", minutes = "", AMPM = "", t;
		thisField = spjs.$(fields[a.fin]);
		if(spjs.$("input:button[id$='SaveItem']").length===0){
			valRaw = spjs.$(fields[a.fin]).find('.ms-formbody').text();
			return spjs.$.trim(valRaw.replace(/[ \xA0]+$/,'')) === "" ? "" : spjs.$.trim(valRaw.replace(/[ \xA0]+$/,''));
		}else{ // If "editform"
			isSP13 = false;
			if(typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15){
				isSP13 = true;
			}
			fieldType = spjs.$(fields[a.fin]).attr('FieldType');
			if(fieldType===undefined){
				alert("[getFieldValue]\nThe attribute \"FieldType\" is missing for the FieldInternalName \""+a.fin+"\".\nEnsure that you use the function init_fields_v2().");
				return false;
			}
			getFieldValueReturnVal = '';
			switch(fieldType){
				case 'ContentTypeChoice':
					getFieldValueReturnVal = thisField.find('option:selected').text();
				break;
				case 'Attachments':
					multiChoice = [];
					thisField.find('#idAttachmentsTable tr').each(function(i,tr){
						multiChoice.push(spjs.$(tr).find('td:first').html());
					});
					getFieldValueReturnVal = multiChoice.join("<br>");
				break;
				case 'SPFieldText':
				case 'SPFieldFile':
				case 'SPFieldNumber':
				case 'SPFieldCurrency':
					getFieldValueReturnVal = thisField.find('input').val();
				break;
				case 'SPFieldChoice':
					if(thisField.find('input:radio').length>0 && thisField.find('select').length===0 && thisField.find('input:text').length===0){
						getFieldValueReturnVal = thisField.find('input:radio:checked').next().text();
					}else if(thisField.find('input:radio').length>0 && thisField.find('input:text').length>0){
						// Fill-in
						if(thisField.find('select').length>0){
							if(thisField.find('input:radio:last').prop('checked')){
								getFieldValueReturnVal = spjs.$.trim(thisField.find('input:text').val());
							}else{
								getFieldValueReturnVal = thisField.find('select').val();
							}
						}else{
							if(thisField.find('input:radio:last').prop('checked')){
								getFieldValueReturnVal = spjs.$.trim(thisField.find('input:text').val());
							}else{
								getFieldValueReturnVal = thisField.find('input:radio:checked').next().text();
							}
						}
					}else{
						getFieldValueReturnVal = thisField.find('select').val();
					}
				break;
				case 'SPFieldMultiChoice':
					multiChoice = [];
					thisField.find('input:checkbox').each(function(i,opt){					
						if(spjs.$(opt).prop("checked")){
							opt = spjs.$(opt);
							if(thisField.find('input:text').length===0){ // No fill-in
								multiChoice.push(opt.next().text());
							}else{ // Fill-in
								if(i+1 === thisField.find('input:checkbox').length){
									multiChoice.push(thisField.find('input:text').val());
								}else{
									multiChoice.push(opt.next().text());
								}
							}
						}
					});
					if(a.delimiter!==undefined && a.delimiter!==''){
						getFieldValueReturnVal = multiChoice.join(a.delimiter);
					}else{
						getFieldValueReturnVal = multiChoice;
					}
				break;
				case 'SPFieldUser':
				case 'SPFieldUserMulti':
					userMulti = [];
					if(isSP13){
						if(typeof SPClientPeoplePicker !== "undefined"){
							spjs.$.each(SPClientPeoplePicker.SPClientPeoplePickerDict[thisField.find("div.sp-peoplepicker-topLevel").attr("id")].GetControlValueAsJSObject(),function(i,o){
								if(a.key==='displayName' || a.key===undefined){
									userMulti.push(o.DisplayText);
								}else if(a.key==='loginName'){
									userMulti.push(o.Key);
								}
							});
						}else{
							userMulti.push("["+a.fin+"]: The people picker is not ready. You must delay the function call, or if you are using DFFS, use code like this: spjs.dffs.beforeProperties[FieldInternalName]");
						}
					}else{
						thisField.find("div[id='divEntityData']").each(function(i,div){
							if(a.key==='displayName' || a.key===undefined){
								userMulti.push(spjs.$(div).attr("displaytext"));
							}else if(a.key==='loginName'){
								userMulti.push(spjs.$(div).attr("key"));
							}					
						});
					}
					if(a.delimiter!==undefined && a.delimiter!==''){
						getFieldValueReturnVal = userMulti.join(a.delimiter);
					}else{
						getFieldValueReturnVal = userMulti;
					}
				break;
				case 'SPFieldLookup':
					if(thisField.find('select option:selected').val()!=='0'){
						getFieldValueReturnVal = thisField.find('select option:selected').text();
					}else{
						getFieldValueReturnVal = '';
					}
				break;
				case 'SPFieldLookup_Input':
					getFieldValueReturnVal = thisField.find('input').val();
				break;
				case 'SPFieldLookupMulti':
					lookupMulti = [];
					thisField.find("select:last option").each(function(i,opt){
						opt = spjs.$(opt);
						lookupMulti.push(opt.text());
					});
					if(a.delimiter!==undefined && a.delimiter!==''){
						getFieldValueReturnVal = lookupMulti.join(a.delimiter);
					}else{
						getFieldValueReturnVal = lookupMulti;
					}
				break;
				case 'SPFieldBoolean':
					getFieldValueReturnVal = thisField.find('input').prop('checked')===true?true:false;
				break;			
				case 'SPFieldURL':
					link = thisField.find('input:first').val();
					descr = thisField.find('input:last').val();
					getFieldValueReturnVal = "<a href='"+link+"'>"+descr+"</a>";
				break;
				case 'SPFieldDateTime':
					date = thisField.find('input:first').val();
					if(date!=='' && thisField.find('select').length>0){					
						AMPM = thisField.find('select:first option:selected').text().match(/AM|PM/);
						if(AMPM === null){
							hour = " "+thisField.find('select:first option:selected').val()+":";
							AMPM = "";
						}else{
							AMPM = " "+AMPM;
							hour = " "+thisField.find('select:first option:selected').text().split(" ")[0]+":";
						}
						minutes = thisField.find('select:last option:selected').val();
					}
					getFieldValueReturnVal = date+hour+minutes+AMPM;
				break;
				case 'SPFieldNote':
					getFieldValueReturnVal = thisField.find('textarea:first').val();
				break;
				case 'SPFieldNote_HTML':
					if(browseris.ie5up && browseris.win32 && !IsAccessibilityFeatureEnabled()){
						if(thisField.find("iframe[class^='ms-rtelong']").contents().find('body').html() !== ""){
							getFieldValueReturnVal = thisField.find("iframe[class^='ms-rtelong']").contents().find('body').html();
						}else{
							getFieldValueReturnVal = thisField.find('textarea:first').val();
						}
					}else{
						getFieldValueReturnVal = thisField.find('textarea:first').val();
					}
				break;
				case 'SPFieldNote_EHTML':
					getFieldValueReturnVal = thisField.find("div[id$='TextField_inplacerte']").html();
				break;
				case 'customHeading':
					getFieldValueReturnVal = '';
				break;
				case 'SPFieldTaxonomyFieldType':
				case 'SPFieldTaxonomyFieldTypeMulti':
					getFieldValueReturnVal = [];
					t = new Microsoft.SharePoint.Taxonomy.ControlObject(thisField.find("div.ms-taxonomy")[0]);
					spjs.$(t.getRawText().split(";")).each(function(i,v){
						getFieldValueReturnVal.push(v.split("|")[0]);
					});
					if(a.delimiter !== undefined){
						getFieldValueReturnVal = getFieldValueReturnVal.join(a.delimiter);
					}					
				break;
				default:
				getFieldValueReturnVal = "Unknown fieldType: "+fieldType;
			}
			return getFieldValueReturnVal !== undefined ? getFieldValueReturnVal : "";
		}
	},
	"init_fields":function(){
		var res = {}, disp, fin, type;
		spjs.$("td.ms-formbody").each(function(){
		var myMatch = spjs.$(this).html().match(/FieldName="(.+)"\s+FieldInternalName="(.+)"\s+FieldType="(.+)"\s+/);	
			if(myMatch !== null){
				// Display name
				disp = myMatch[1];
				// FieldInternalName
				fin = myMatch[2];
				// FieldType
				type = myMatch[3];
				if(type === "SPFieldNote"){
					if(spjs.$(this).find('script').length>0){
						type=type+"_HTML";
					}else if(spjs.$(this).find("div[id$='TextField_inplacerte']").length>0){
						type=type+"_EHTML";
					}				
				}
				if(type === "SPFieldLookup"){
					if(spjs.$(this).find("input").length>0){
						type=type+"_Input";
					}
				}
				// HTML Calc
				if(type==='SPFieldCalculated' && spjs.$(this).text().match(/(<([^>]+)>)/ig)!==null){
					spjs.$(this).html(spjs.$(this).text());
				}		
				// Build object
				res[fin] = this.parentNode;
				spjs.$(res[fin]).attr('FieldDispName',disp);
				spjs.$(res[fin]).attr('FieldType',type);
			}		
		});
		return res;
	},
	"addItem":function(argObj){
		var qRes = spjs.utility.updateListItem({'action':'new','listName':argObj.listName,'listBaseUrl':argObj.listBaseUrl,'data':argObj.data});
		return qRes;
	},
	"deleteItem":function(argObj){
		var qRes = spjs.utility.updateListItem({'action':'delete','listName':argObj.listName,'listBaseUrl':argObj.listBaseUrl,'id':argObj.id,'docFullUrl':argObj.docFullUrl});
		return qRes;
	},
	"updateItem":function(argObj){
		var qRes = spjs.utility.updateListItem({'action':'update','listName':argObj.listName,'listBaseUrl':argObj.listBaseUrl,'id':argObj.id,'data':argObj.data});
		return qRes;
	},
	"updateListItem":function(argObj){
		var content, result, listURL;
		if(argObj.listBaseUrl===undefined){
			argObj.listBaseUrl = L_Menu_BaseUrl;
		}
		if(argObj.id!==undefined && typeof(argObj.id)!=='object'){
			argObj.id = argObj.id.toString().split(',');
		}
		content = [];
		content.push("<UpdateListItems xmlns='http://schemas.microsoft.com/sharepoint/soap/'>");
		content.push("<listName>"+argObj.listName+"</listName>");
		content.push("<updates>");	
		switch(argObj.action){
			case 'new':			
				if(argObj.folderName !== undefined){ // Folder
					content.push("<Batch OnError='Continue' ");
					if(argObj.rootFolder!==undefined){
						content.push("RootFolder='"+argObj.rootFolder+"'");
					}
					content.push(" PreCalc='TRUE'>");				
					content.push("<Method ID='1' Cmd='New'>");
					content.push("<Field Name='ID'>New</Field>");
					content.push("<Field Name='FSObjType'>1</Field>");
					content.push("<Field Name='BaseName'>"+argObj.folderName+"</Field>");
					content.push("<Field Name='Title'>"+argObj.folderName+"</Field>");
					content.push("</Method>");			
				}else{ // List
					content.push("<Batch OnError='Continue'>");				
					content.push("<Method ID='1' Cmd='New'>");
					content.push("<Field Name='ID'>0</Field>");
					spjs.$.each(argObj.data,function(fin,val){
						content.push("<Field Name='"+fin+"'><![CDATA["+val+"]]></Field>");
					});		
					content.push("</Method>");						
				}			
			break;
			case 'update':
				content.push("<Batch OnError='Continue'>");	
				spjs.$.each(argObj.id,function(i,id){						
					content.push("<Method ID='"+(i+1)+"' Cmd='Update'>");
					content.push("<Field Name='ID'>"+id+"</Field>");
					spjs.$.each(argObj.data,function(fin,val){
						content.push("<Field Name='"+fin+"'><![CDATA["+val+"]]></Field>");
					});		
					content.push("</Method>");
				});		
			break;
			case 'delete':
				// List items			
				if(argObj.docFullUrl===undefined){
					content.push("<Batch OnError='Continue'>");
					spjs.$.each(argObj.id,function(i,id){				
						content.push("<Method ID='"+(i+1)+"' Cmd='Delete'>");
						content.push("<Field Name='ID'>"+id+"</Field>");
						content.push("</Method>");
					});
				// Document
				}else if(argObj.id.length === 1 && argObj.docFullUrl!==undefined){
					content.push("<Batch OnError='Continue' PreCalc='TRUE'>");
					content.push("<Method ID='1' Cmd='Delete'>");
					content.push("<Field Name='ID'>"+argObj.id[0]+"</Field>");
					content.push("<Field Name='FileRef'>"+argObj.docFullUrl+"</Field>");	
					content.push("</Method>");	
				}else{
					alert("You cannot delete more than one document at a time!");		
				}		
			break;
		}
		content.push("</Batch>");
		content.push("</updates>");
		content.push("</UpdateListItems>");
		content = content.join('');
		result = {success:false,errorText:null,errorCode:null};
		spjs.utility.wrapSoap(argObj.listBaseUrl + '/_vti_bin/lists.asmx','http://schemas.microsoft.com/sharepoint/soap/UpdateListItems',content,function(data){
			if(spjs.$(data).find('ErrorText').length>0) {
				result.errorText = spjs.$(data).find('ErrorText').text();
				result.errorCode = spjs.$(data).find('ErrorCode').text();
				// Duplicate folder names			
				if(result.errorCode === "0x8107090d" && argObj.folderName !== undefined){
					result.errorText = "A folder named \""+argObj.folderName+"\" already exist";
				}			
			}else{
				result.success = true;
				if(argObj.action!=='delete'){				
					result.id = spjs.$(data).filterNode('z:row').attr('ows_ID');
					listURL = spjs.$(data).filterNode('z:row').attr('ows_EncodedAbsUrl');
					result.listURL = listURL.substring(0,listURL.lastIndexOf('/'));
				}
			}
		});
		return result;
	}
};

// http://www.steveworkman.com/html5-2/javascript/2011/improving-javascript-xml-node-finding-performance-by-2000/
spjs.$.fn.filterNode = function(name) {
	return this.find('*').filter(function() {
		return this.nodeName === name;
	});
};

/***********************************************/
/****  Compatibility with existing scripts  ****/
/***********************************************/
function doResizeDialog(){
	spjs.utility.resizeDlg();
}

function spjs_AddList(listName,listBaseUrl,listDescription){
	return spjs.utility.addList(listName,listBaseUrl,listDescription);
}

function spjs_UpdateList(listName,listBaseUrl,newFieldsObjArr,updFieldsObjArr,deleteFieldsArr){
	return spjs.utility.updateList(listName,listBaseUrl,newFieldsObjArr,updFieldsObjArr,deleteFieldsArr);
}

function getUserInfo_v2(loginOrUserID,customProp){
	return spjs.utility.userInfo(loginOrUserID,customProp);
}

function spjs_getItemByID(argObj){
	return spjs.utility.getItemByID(argObj);
}

function spjs_QueryItems(argObj){
	return spjs.utility.queryItems(argObj);
}

function spjs_wrapQueryContent(paramObj){
	return spjs.utility.wrapQuery(paramObj);
}

function spjs_wrapSoapRequest(webserviceUrl,requestHeader,soapBody,successFunc){
	spjs.utility.wrapSoap(webserviceUrl,requestHeader,soapBody,successFunc);
}

function setFieldValue(fin,newVal,onLoad){	
	spjs.utility.setFieldValue(fin,newVal,onLoad);
}

function getFieldValue(fin,dispform,multiValueJoinBy,optionalFilter){
	return spjs.utility.getFieldValue({"fin":fin,"delimiter":multiValueJoinBy,"key":optionalFilter});
}

function init_fields_v2(){
	return spjs.utility.init_fields();	
}

function spjs_addItem(argObj){
	return spjs.utility.addItem(argObj);
}

function spjs_deleteItem(argObj){
	return spjs.utility.deleteItem(argObj);
}

function spjs_updateItem(argObj){
	return spjs.utility.updateItem(argObj);
}

function spjs_UpdateListItem(argObj){
	return spjs.utility.updateListItem(argObj);
}